package project1;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JTextField;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;

import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

import java.io.IOException;

import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

import com.google.gson.Gson;

public class GPT {

    private static String apiKey;

    public GPT(String apiKey) {
        GPT.apiKey = apiKey;
    }

    public static String generateText(String prompt) throws IOException {
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Gson gson = new Gson();
        JsonObject json = new JsonObject();
        json.addProperty("prompt", prompt);
        String jsonString = gson.toJson(json);

        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(jsonString,mediaType);
        Request request = new Request.Builder()
                .url("https://api.openai.com/v1/engines/davinci/completions")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + apiKey)
                .build();

        Response response = client.newCall(request).execute();
        if (response.code() == 401) {
            throw new IOException("Unauthorized: Invalid API key");
        }
        if (response.code() == 429) {
            throw new IOException("Too Many Requests: Usage limits reached");
        }
        if (response.code() != 200) {
            throw new IOException("Unexpected response code: " + response.code());
        }
        return response.body().string();
    }
}